package datamodel;


public class Log {

	private LogPost root = null;

	private LogPost lastLogPost;

	public Log() {
		lastLogPost = root;
	}

	public void addLogPost(SubSystem rootSS, String action) {
		LogPost currentPost = new LogPost(lastLogPost, action,
				getSystemState(rootSS));
		if (root == null) {
			// this is the first logpost and thus the root
			root = currentPost;
		} else {
			lastLogPost.getPostChildren().add(currentPost);
		}
		lastLogPost = currentPost;

	}

	private SubSystem getSystemState(SubSystem ss) {
		return (SubSystem)ss.clone((SubSystem)ss.getParent());
	}

	public LogPost getLastLogPost() {
		return lastLogPost;
	}

	public void setLastLogPost(LogPost lastLogPost) {
		this.lastLogPost = lastLogPost;
	}

	public LogPost getRoot() {
		return root;
	}

	public void setRoot(LogPost root) {
		this.root = root;
	}

}
