package datamodel;

import java.util.ArrayList;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

public class LogPost extends DefaultMutableTreeNode {
	
	static final long serialVersionUID=1;
	
	private LogPost parentPost;
	private ArrayList<LogPost> postChildren;
	private String action;
	private SubSystem systemStateRootNode;
	
	public LogPost(LogPost parent, String action, SubSystem root){
		this.action=action;
		this.parentPost=parent;
		this.systemStateRootNode=root;
		this.postChildren=new ArrayList<LogPost>();
	}

	public String getAction() {
		return action;
	}

	public void setAction(String action) {
		this.action = action;
	}

	public ArrayList<LogPost> getPostChildren() {
		return postChildren;
	}

	public void setPostChildren(ArrayList<LogPost> children) {
		this.postChildren = children;
	}

	public LogPost getParentPost() {
		return parentPost;
	}

	public void setParentPost(LogPost parent) {
		this.parentPost = parent;
	}

	public SubSystem getSystemStateRootNode() {
		return systemStateRootNode;
	}

	public void setSystemStateRootNode(SubSystem systemStateRootNode) {
		this.systemStateRootNode = systemStateRootNode;
	}
	
	public String toString(){
		return action;
	}
	
	public void makeLogTree(DefaultTreeModel model) {
		model.insertNodeInto(this, this.parent, this.parent.getChildCount());		
		for (LogPost child : this.getPostChildren()) {
			child.makeLogTree(model);
		}		
	}
}
