package gui;

import gui.setup.OpPanel;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class CalcOptionsPanel extends JPanel{
	
	private JRadioButton highButton;
	private JRadioButton normalButton;
	private JRadioButton lowButton;
		
	private OpPanel opPanel;
	
	private JButton okButton;
	private JButton cancelButton;
	
	public CalcOptionsPanel() {
		super();
		highButton=new JRadioButton("High (Slower)");		
		normalButton=new JRadioButton("Normal");		
		lowButton=new JRadioButton("Low (Faster)");
		highButton.setToolTipText("This runs the calculation for a longer time");
		normalButton.setToolTipText("This runs the calculation for a time " +
				"that usually gives a satisfactory accuracy");
		lowButton.setToolTipText("This runs the calculation for a shorter time");
		
		ButtonGroup buttonGroup=new ButtonGroup();
		buttonGroup.add(highButton);
		buttonGroup.add(normalButton);
		buttonGroup.add(lowButton);
		
		JPanel buttonPanel=new JPanel(new GridLayout(3,0));
		buttonPanel.add(highButton);
		buttonPanel.add(normalButton);
		buttonPanel.add(lowButton);		
		buttonPanel.setBorder(BorderFactory.createTitledBorder("Calculation accuracy"));
		
		setLayout(new BorderLayout());
		add(buttonPanel, BorderLayout.CENTER);
		opPanel=new OpPanel();		
		add(opPanel, BorderLayout.SOUTH);
		
		JPanel okPanel=new JPanel();
		okButton=new JButton("OK");
		cancelButton=new JButton("Cancel");
		okPanel.add(okButton);
		okPanel.add(cancelButton);		
		add(okPanel, BorderLayout.EAST);		
		
	}

}
