package gui;

import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.TitledBorder;

import computations.GainCalculator;

public class CalcPanel extends JPanel{
	
	private JRadioButton simButton;
	private JRadioButton mvaButton;	
	private TitledBorder border;	
	private JButton calcButton;
	private JButton cancelButton;
	private JButton optionsButton;
		
	public CalcPanel(){
		simButton=new JRadioButton("Simulation");
		simButton.setSelected(true);
		mvaButton=new JRadioButton("MVA");		
		mvaButton.setEnabled(false);//not implemented yet
		
		ButtonGroup buttonGroup=new ButtonGroup();
		buttonGroup.add(simButton);
		buttonGroup.add(mvaButton);		
				
		JPanel rButtonPanel=new JPanel(new GridLayout(2, 0));
		rButtonPanel.add(simButton);		
		rButtonPanel.add(mvaButton);	
		
		calcButton=new JButton("Calculate");
		cancelButton=new JButton("Cancel");
		optionsButton=new JButton("Options");
		
		JPanel jButtonPanel=new JPanel(new GridLayout(3, 0));
		jButtonPanel.add(calcButton);		
		jButtonPanel.add(cancelButton);	
		jButtonPanel.add(optionsButton);	
		
		setLayout(new GridLayout(0, 2));
		add(rButtonPanel);
		add(jButtonPanel);
		
		border=BorderFactory.createTitledBorder("");
		setBorder(border);
		setSize(250, 150);
	}
	
	public int getCalculationMethod() {
		if (simButton.isSelected()) {
			return GainCalculator.SIMULATION;
		} else {
			return GainCalculator.MVA;
		}
	}
	
	public TitledBorder getBorder() {		
		return border;		
	}
	public JButton getCalcButton() {
		return calcButton;
	}
	public JButton getCancelButton() {
		return cancelButton;
	}
	public JButton getOptionsButton() {
		return optionsButton;
	}

	public JRadioButton getMvaButton() {
		return mvaButton;
	}

	public JRadioButton getSimButton() {
		return simButton;
	}
	
}
