package gui;

import java.awt.GridLayout;
import java.util.Enumeration;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;

import datamodel.Component;
import datamodel.Primitive;
import datamodel.LogPost;
import datamodel.SubSystem;

public class SAMeTreePanel extends JPanel {	
	
	private JTree tree;	
	
	public SAMeTreePanel(){
		super(new GridLayout(1,0));	
		tree=new JTree();
		tree.setShowsRootHandles(true);
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		JScrollPane scroll=new JScrollPane(tree);
		add(scroll);
	}

	public DefaultTreeModel makeTreeModel(SubSystem root) {
		DefaultTreeModel newModel=new DefaultTreeModel(root);	
		/*Enumeration e=root.children();		
		while(e.hasMoreElements()){
			((Component)e.nextElement()).makeTree(newModel);
		}	*/
		return newModel;
	}	
	public DefaultTreeModel makeLogTreeModel(LogPost root) {
		DefaultTreeModel newModel=new DefaultTreeModel(root);
		for (LogPost child : root.getPostChildren()) {			
			child.makeLogTree(newModel);
		}		
		return newModel;
	}	
	
	public JTree getTree() {
		return tree;
	}	
}
