package gui.setup;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class OpPanel extends JPanel{
	
	/*only utilisation is implemented so far*/
	public final String[] opTypes={"Utilisation", "Response time" , "Kleinrock saturation point"};
	
	public static final int OP_UTILISATION=0;
	public static final int OP_RESPONSE_TIME=1;
	public static final int OP_KLEINROCK_SATURATION=2;
	
	private JComboBox combo;
	private JTextField opText;
	
	public OpPanel(){
		super();
		JLabel comboLabel=new JLabel("OP type:");
		combo=new JComboBox(opTypes);
		JLabel opLabel=new JLabel("Operating point:");
		opText=new JTextField();			
		
		combo.setSelectedIndex(OP_UTILISATION);
		
		setLayout(new GridLayout(2,2));
		add(comboLabel);		
		add(combo);		
		add(opLabel);
		add(opText);		
		setBorder(BorderFactory.createTitledBorder("Operating Point"));
		setMaximumSize(new Dimension(450, 150));
		setMinimumSize(new Dimension(350, 50));
	}


	public int getOpType(){
		return combo.getSelectedIndex();
	}
	public double getOpValue() throws NumberFormatException{		
		try {
			return (new Double(opText.getText())).doubleValue();	
		} catch (NumberFormatException e) {
			throw new NumberFormatException();
		}			
	}


	public JComboBox getCombo() {
		return combo;
	}

}
