package gui.setup;


import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TreeSelectionListener;

import datamodel.SubSystem;
import datamodel.System;

public class RequirementPanel extends JPanel implements ActionListener{

	private JTextField processingText;
	private JTextField storageText;
	private JTextField connectivityText;
	
	private OpPanel opPanel;
	
	private JButton okButton;
	
	private JFrame frame;
	
	private System system;
	
	public RequirementPanel(JFrame frame, System system){
		super();
		this.frame=frame;
		this.system=system;
		JLabel procLabel=new JLabel("Processing:");
		JLabel storLabel=new JLabel("Storage:");
		JLabel connLabel=new JLabel("Connectivity:");
		
		processingText=new JTextField();
		storageText=new JTextField();
		connectivityText=new JTextField();
		
		JPanel reqPanel=new JPanel();
		reqPanel.setLayout(new GridLayout(3,3));
		reqPanel.add(procLabel);
		reqPanel.add(processingText);
		reqPanel.add(storLabel);
		reqPanel.add(storageText);
		reqPanel.add(connLabel);
		reqPanel.add(connectivityText);		
		reqPanel.setBorder(BorderFactory.createTitledBorder("Requirements"));
		reqPanel.setMaximumSize(new Dimension(250, 200));
		reqPanel.setMinimumSize(new Dimension(150, 150));
		
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		add(reqPanel);
		
		opPanel=new OpPanel();	
		add(opPanel);
		
		//JPanel okPanel=new JPanel();
		okButton=new JButton("Proceed");
		okButton.addActionListener(this);
		//okPanel.add(okButton);
		add(okButton);
		setOpaque(true);
		frame.getRootPane().setDefaultButton(okButton);
	}


	public void actionPerformed(ActionEvent e) {
		// listen to okbutton
		if (e.getSource()==okButton) {			
			if(opPanel.getOpType()==OpPanel.OP_UTILISATION){
				try{	
					if(opPanel.getOpValue()<0 || opPanel.getOpValue()>1){
						JOptionPane.showMessageDialog(this, 
								"Utilisation must be between 0.0 and 1.0", "Error", 
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					system.setOpType(opPanel.getOpType());
					system.setOP(opPanel.getOpValue());
					system.setRequirementProcessing(Double.parseDouble(processingText.getText()));
					system.setRequirementStorage(Double.parseDouble(storageText.getText()));
					system.setRequirementConnectivity((Double.parseDouble(connectivityText.getText())));					
					frame.getContentPane().removeAll();
					frame.getContentPane().add(new BaselinePanel(frame, system));
					frame.pack();					
				}catch (Exception x) {
					JOptionPane.showMessageDialog(this, "Fill inn all the fields correctly!", 
							"Missing data", JOptionPane.ERROR_MESSAGE);					
				}
			}else {
				JOptionPane.showMessageDialog(this, "Only utilisation as " +
						"operating point has been implemented yet. Sorry!", 
						"Choose another type of operating point", JOptionPane.ERROR_MESSAGE);
			}
		}
		
	}


}
