package gui.setup;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import datamodel.SubSystem;

public class SubSysPropertiesPanel extends JPanel implements ActionListener{

	private JTextField nameText;
	private JTextField maxReplicationText;
	
	private JButton okButton;
	private JButton cancelButton;

	private SubSystem subsys;
	
	private JDialog frame;
	
	public SubSysPropertiesPanel(JDialog frame, SubSystem subsys) {
		super(new BorderLayout());
		this.frame=frame;
		this.subsys=subsys;
		JLabel nameLabel=new JLabel("Name:");
		nameText=new JTextField();
		JLabel maxReplicationLabel=new JLabel("Maximum replication:");
		maxReplicationText=new JTextField();
		
		JPanel mainPanel=new JPanel();
		mainPanel.setLayout(new GridLayout(4,2));
		mainPanel.add(Box.createRigidArea(new Dimension(10,0)));
		mainPanel.add(Box.createRigidArea(new Dimension(10,0)));
		mainPanel.add(nameLabel);
		mainPanel.add(nameText);		
		mainPanel.add(Box.createRigidArea(new Dimension(10,0)));
		mainPanel.add(Box.createRigidArea(new Dimension(10,0)));
		mainPanel.add(maxReplicationLabel);
		mainPanel.add(maxReplicationText);
				
		okButton=new JButton("OK");
		okButton.addActionListener(this);
		cancelButton=new JButton("Cancel");
		cancelButton.addActionListener(this);
		JPanel okPanel=new JPanel();
		okPanel.add(okButton);
		okPanel.add(cancelButton);
				
		add(mainPanel);		
		add(okPanel, BorderLayout.SOUTH);
		
		if(subsys.getName()!=null){
			initData();
		}
		frame.getRootPane().setDefaultButton(okButton);
	}
	
	private void initData(){
		nameText.setText(subsys.getName());
		maxReplicationText.setText(subsys.getMaxReplication()+"");
	}
	
	public void actionPerformed(ActionEvent e) {
		// listen to okbutton
		if (e.getSource()==okButton) {						
			try{				
				if(nameText.getText()==null){
					throw new NullPointerException();
				}
				subsys.setName(nameText.getText());
				subsys.setMaxReplication((Integer.parseInt(maxReplicationText.getText())));				
				frame.dispose();				
			}catch (Exception x) {
				JOptionPane.showMessageDialog(this, "Fill inn all the fields correctly!", 
						"Missing data", JOptionPane.ERROR_MESSAGE);					
			}			
		}else if (e.getSource()==cancelButton) {
			frame.dispose();
		}
	}
}
