package gui.tune;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import computations.Tuner;

public class DimensionPanel extends JPanel {
	
	private JRadioButton processingButton;
	private JRadioButton storageButton;
	private JRadioButton connectivityButton;
	
	private JTextField reqText;
	private JTextField gainText;
	
	public DimensionPanel(){
		processingButton=new JRadioButton("Processing");
		processingButton.setSelected(true);
		storageButton=new JRadioButton("Storage");
		connectivityButton=new JRadioButton("Connectivity");
		
		ButtonGroup buttonGroup=new ButtonGroup();
		buttonGroup.add(processingButton);
		buttonGroup.add(storageButton);
		buttonGroup.add(connectivityButton);
				
		JLabel reqLabel=new JLabel("Requirement:");
		reqText=new JTextField();
		JLabel gainLabel=new JLabel("Gain:");
		gainText=new JTextField();
		
		JPanel textPanel=new JPanel(new GridLayout(2, 2));
		textPanel.add(reqLabel);
		textPanel.add(reqText);
		textPanel.add(gainLabel);
		textPanel.add(gainText);
		
		JPanel panel=new JPanel(new GridLayout(4, 0));
		panel.add(processingButton);		
		panel.add(storageButton);		
		panel.add(connectivityButton);
		panel.add(textPanel);
				
		
		setLayout(new BorderLayout());
		add(panel, BorderLayout.CENTER);
		
		setBorder(BorderFactory.createTitledBorder("Dimension"));
		setMaximumSize(new Dimension(250, 250));
		setMinimumSize(new Dimension(150, 150));
		
	}

	protected JRadioButton getConnectivityButton() {
		return connectivityButton;
	}

	public JTextField getGainText() {
		return gainText;
	}

	protected JRadioButton getProcessingButton() {
		return processingButton;
	}

	public JTextField getReqText() {
		return reqText;
	}

	protected JRadioButton getStorageButton() {
		return storageButton;
	}
	
	protected int getSelectedDimension(){
		if(processingButton.isSelected()){
			return Tuner.PROCESSING;
		}else if (storageButton.isSelected()) {
			return Tuner.STORAGE;
		}else{
			return Tuner.CONNECTIVITY;
		}
	}

}
