package gui.tune;

import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import computations.Tuner;

public class ModePanel extends JPanel{

	private JRadioButton uniformRadio;
	private JRadioButton nonUniformRadio;
	
	public ModePanel(){
		super();
		uniformRadio=new JRadioButton("Uniform");
		uniformRadio.setSelected(true);
		nonUniformRadio=new JRadioButton("Non-uniform");
		
		uniformRadio.setToolTipText("This mode scales the whole chosen subtree by the same scalefactor.");
		nonUniformRadio.setToolTipText("This mode scales only the chosen unit by the chosen scalefactor.");
		
		ButtonGroup buttonGroup=new ButtonGroup();
		buttonGroup.add(uniformRadio);
		buttonGroup.add(nonUniformRadio);
		
		setLayout(new GridLayout(2,0));
		add(uniformRadio);
		//add(new JLabel(uniformRadio.getToolTipText()));
		add(nonUniformRadio);
		//add(new JLabel(nonUniformRadio.getToolTipText()));
		setMaximumSize(new Dimension(350, 250));
		setMinimumSize(new Dimension(150, 150));
		
		setBorder(BorderFactory.createTitledBorder("Scaling mode"));
	}
	
	public int getMode(){
		if(uniformRadio.isSelected()){
			return Tuner.UNIFORM;
		}else{
			return Tuner.NONUNIFORM;
		}
	}
	
}
