package gui.tune;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.text.NumberFormat;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import computations.Tuner;

import datamodel.DataBaseHandler;
import datamodel.Primitive;

public class PrimitiveTunePanel extends JPanel{

	private JTextField nameText;
	private JTextField maxGainText;
	private JTextField upgradeText;
	private JTextField maxUpgradeText;
	private JTextField replicationText;
	private JTextField maxReplicationText;
	
	public PrimitiveTunePanel() {
		super(new GridLayout(3,4));
		JLabel nameLabel=new JLabel("Name:");
		nameText=new JTextField();
		nameText.setEditable(false);
		JLabel maxGainLabel=new JLabel("Maximum gain:");
		maxGainText=new JTextField();
		maxGainText.setEditable(false);
		JLabel upgradeLabel=new JLabel("Upgrade:");
		upgradeText=new JTextField();
		upgradeText.setEditable(false);
		JLabel maxUpgradeLabel=new JLabel("Maximum upgrade:");
		maxUpgradeText=new JTextField();
		maxUpgradeText.setEditable(false);
		JLabel replicationLabel=new JLabel("Replication:");
		replicationText=new JTextField();
		replicationText.setEditable(false);
		JLabel maxReplicationLabel=new JLabel("Maximum replication:");
		maxReplicationText=new JTextField();
		maxReplicationText.setEditable(false);
		
		add(nameLabel);
		add(nameText);		
		add(maxGainLabel);
		add(maxGainText);
		add(upgradeLabel);
		add(upgradeText);
		add(maxUpgradeLabel);
		add(maxUpgradeText);
		add(replicationLabel);
		add(replicationText);
		add(maxReplicationLabel);
		add(maxReplicationText);
		setMaximumSize(new Dimension(800, 150));
		setMinimumSize(new Dimension(300, 100));
		setBorder(BorderFactory.createTitledBorder("Primitive properties"));
	}
	public void setData(Primitive device, int dimension){
		nameText.setText(device.getName());
		replicationText.setText(device.getReplication()+"");
		maxReplicationText.setText(device.getMaxReplication()+"");
		switch (dimension) {
		case Tuner.PROCESSING:
			upgradeText.setText(device.getUpgradeFactorProcessing()+"");
			maxUpgradeText.setText(DataBaseHandler.
					getMaxUpgradeFactor(device.getProcessingSpeed(), Tuner.PROCESSING, device.getDeviceType())+"");
			break;
		case Tuner.STORAGE:
			upgradeText.setText(device.getUpgradeFactorStorage()+"");
			maxUpgradeText.setText(DataBaseHandler.
					getMaxUpgradeFactor(device.getStorageCapacity(), Tuner.STORAGE, device.getDeviceType())+"");
			break;
		case Tuner.CONNECTIVITY:
			upgradeText.setText(device.getUpgradeFactorConnectivity()+"");
			maxUpgradeText.setText(DataBaseHandler.
					getMaxUpgradeFactor(device.getConnectivity(), Tuner.CONNECTIVITY, device.getDeviceType())+"");
			break;
		default:
			break;
		}
		double d1=new Double(maxUpgradeText.getText()).doubleValue();
		double d2=new Double(maxReplicationText.getText()).doubleValue();
		double f=d1*d2;
		NumberFormat form=NumberFormat.getInstance();
		form.setGroupingUsed(false);
		f=new Double(form.format(f)).doubleValue();
		maxGainText.setText(f+"");
	}
	public void clearData(){
		nameText.setText("");
		replicationText.setText("");
		maxReplicationText.setText("");
		upgradeText.setText("");
		maxUpgradeText.setText("");
		maxGainText.setText("");
	}

}
