package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.StringTokenizer;

import datamodel.Primitive;
import datamodel.SubSystem;

public class SAMeFileReader {
		
	public SAMeFileReader() {

	}
	
	
	public static SubSystem readSPModel(File file) throws Exception{
		SubSystem parent=null;
		SubSystem previous;
		SubSystem newSubSystem;
		Primitive newPrimitive;
		String type;
		BufferedReader in=new BufferedReader(new FileReader(file));
		String line=in.readLine();
		StringTokenizer st;			
		/*create the root first*/
		st=new StringTokenizer(line);
		if(st.nextToken().equals("1")){
			throw new Exception("Root must be subsystem! ");
		}
		newSubSystem=new SubSystem(st.nextToken(), new Integer(st.nextToken()).intValue());
		parent=newSubSystem;
		previous=newSubSystem;
		/*root created**********/
		line=in.readLine();
		while(line!=null){
			//make objects and add them to the tree
			st=new StringTokenizer(line);				
			type=st.nextToken();
			if(type.equals("0")){
				newSubSystem=new SubSystem(st.nextToken(), new Integer(st.nextToken()).intValue());
				parent.add(newSubSystem);
				previous=newSubSystem;
			}else if(type.equals("1")){
				newPrimitive=new Primitive(st.nextToken(), new Double(st.nextToken()).doubleValue(), new Integer(st.nextToken()).intValue());
				newPrimitive.setData();
				parent.add(newPrimitive);
			}else if(type.equals("<")){
				parent=previous;
			}else if(type.equals(">")){
				parent=(SubSystem)parent.getParent();
			}else{
				throw new Exception("Unknown type! ");
			}	
			line=in.readLine();
		}			
		 
		return parent;
	}
	
}
