package simulator;

import desmoj.core.simulator.Model;
import desmoj.core.simulator.SimProcess;
import desmoj.core.simulator.SimTime;

public class User extends SimProcess {

	private SimulatorModel simsamModel;

	public User(Model owner, String name, boolean showInTrace) {
		super(owner, name, showInTrace);
		simsamModel = (SimulatorModel) owner;
	}

	private void useResource(SAMResource theResource, int index) {
		theResource.provide(1);
		hold(new SimTime(simsamModel.getServiceDemand(index)));
		theResource.takeBack(1);
	}
	/*
	 *to support workflow simulation, the resources could have an array of service demands
	 *there could be a double for-loop with i for each step in the workflow, and j for each
	 *resource
	 *for i in resource.demands.length
	 *   for j in numOfResources
	 *       res=getRes(i)
	 *       useDemandNumber(res, i, j) 
	 */
	

	public void lifeCycle() {
		int n = simsamModel.getResources().size();
		SAMResource res;
		while (true) {
			for (int i = 0; i < n; i++) {
				res=simsamModel.getResources().get(i);
				useResource(res, i);
			}			
		}
	}
}